Backend API
<template>
<DxCardView
id="cardView"
:data-source="orders"
key-expr="ID"
:allow-column-reordering="true"
cards-per-row="auto"
:card-min-width="300"
>
<DxColumn
data-field="OrderNumber"
:allow-reordering="false"
/>
<DxColumn data-field="SaleAmount"/>
<DxColumn data-field="Customer"/>
<DxColumn data-field="Location"/>
<DxColumn
data-field="OrderDate"
data-type="date"
/>
<DxColumn
data-field="DeliveryDate"
data-type="date"
/>
</DxCardView>
</template>
<script setup lang="ts">
import { DxCardView, DxColumn } from 'devextreme-vue/card-view';
import { orders } from './data.ts';
</script>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export interface Order {
ID: number;
OrderNumber: number;
OrderDate: string;
DeliveryDate: string;
SaleAmount: number,
Terms: string;
Location: string;
Customer: string;
}
export const orders: Order[] = [{
ID: 1,
OrderNumber: 35703,
OrderDate: '2024/04/10',
DeliveryDate: '2024/04/13',
SaleAmount: 11800,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: '2024/01/12',
DeliveryDate: '2024/01/13',
SaleAmount: 16050,
Terms: '15 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: '2024/01/22',
DeliveryDate: '2024/01/27',
SaleAmount: 14750,
Terms: '15 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: '2024/02/07',
DeliveryDate: '2024/02/10',
SaleAmount: 3725,
Terms: '15 Days',
Location: 'Denver, CO',
Customer: 'Todd Hoffman',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: '2024/03/01',
DeliveryDate: '2024/03/03',
SaleAmount: 7800,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: '2024/02/15',
DeliveryDate: '2024/02/17',
SaleAmount: 20500,
Terms: '15 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: '2024/02/04',
DeliveryDate: '2024/02/10',
SaleAmount: 9050,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: '2024/02/15',
DeliveryDate: '2024/02/17',
SaleAmount: 20400,
Terms: '30 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: '2024/05/16',
DeliveryDate: '2024/05/19',
SaleAmount: 11050,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
}, {
ID: 32,
OrderNumber: 58292,
OrderDate: '2024/05/13',
DeliveryDate: '2024/05/19',
SaleAmount: 13500,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 36,
OrderNumber: 62427,
OrderDate: '2024/01/27',
DeliveryDate: '2024/02/03',
SaleAmount: 23500,
Terms: '15 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 39,
OrderNumber: 65977,
OrderDate: '2024/02/05',
DeliveryDate: '2024/02/10',
SaleAmount: 2550,
Terms: '15 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
}, {
ID: 42,
OrderNumber: 68428,
OrderDate: '2024/04/10',
DeliveryDate: '2024/04/14',
SaleAmount: 10500,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 43,
OrderNumber: 69477,
OrderDate: '2024/03/09',
DeliveryDate: '2024/03/10',
SaleAmount: 14200,
Terms: '15 Days',
Location: 'Anaheim, CA',
Customer: 'Harv Mudd',
}, {
ID: 46,
OrderNumber: 72947,
OrderDate: '2024/01/14',
DeliveryDate: '2024/01/20',
SaleAmount: 13350,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 47,
OrderNumber: 73088,
OrderDate: '2024/03/25',
DeliveryDate: '2024/03/31',
SaleAmount: 8600,
Terms: '30 Days',
Location: 'Reno, NV',
Customer: 'Clark Morgan',
}, {
ID: 51,
OrderNumber: 77297,
OrderDate: '2024/04/30',
DeliveryDate: '2024/05/05',
SaleAmount: 10850,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
}, {
ID: 56,
OrderNumber: 84744,
OrderDate: '2024/02/10',
DeliveryDate: '2024/02/17',
SaleAmount: 4650,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 57,
OrderNumber: 85028,
OrderDate: '2024/05/17',
DeliveryDate: '2024/05/19',
SaleAmount: 2575,
Terms: '30 Days',
Location: 'Reno, NV',
Customer: 'Clark Morgan',
}, {
ID: 59,
OrderNumber: 87297,
OrderDate: '2024/04/21',
DeliveryDate: '2024/04/28',
SaleAmount: 14200,
Terms: '30 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
}, {
ID: 65,
OrderNumber: 94726,
OrderDate: '2024/05/22',
DeliveryDate: '2024/05/26',
SaleAmount: 20500,
Terms: '15 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
}, {
ID: 66,
OrderNumber: 95266,
OrderDate: '2024/03/10',
DeliveryDate: '2024/03/17',
SaleAmount: 9050,
Terms: '15 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 69,
OrderNumber: 98477,
OrderDate: '2024/01/01',
DeliveryDate: '2024/01/06',
SaleAmount: 23500,
Terms: '15 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
}, {
ID: 78,
OrderNumber: 174884,
OrderDate: '2024/04/10',
DeliveryDate: '2024/04/14',
SaleAmount: 7200,
Terms: '30 Days',
Location: 'Denver, CO',
Customer: 'Todd Hoffman',
}, {
ID: 81,
OrderNumber: 188877,
OrderDate: '2024/02/11',
DeliveryDate: '2024/02/17',
SaleAmount: 8750,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
}, {
ID: 82,
OrderNumber: 191883,
OrderDate: '2024/02/05',
DeliveryDate: '2024/02/10',
SaleAmount: 9900,
Terms: '30 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 83,
OrderNumber: 192474,
OrderDate: '2024/01/21',
DeliveryDate: '2024/01/27',
SaleAmount: 12800,
Terms: '30 Days',
Location: 'Anaheim, CA',
Customer: 'Harv Mudd',
}, {
ID: 84,
OrderNumber: 193847,
OrderDate: '2024/03/21',
DeliveryDate: '2024/03/24',
SaleAmount: 14100,
Terms: '30 Days',
Location: 'San Diego, CA',
Customer: 'Harv Mudd',
}, {
ID: 85,
OrderNumber: 194877,
OrderDate: '2024/03/06',
DeliveryDate: '2024/03/10',
SaleAmount: 4750,
Terms: '30 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
}, {
ID: 86,
OrderNumber: 195746,
OrderDate: '2024/05/26',
DeliveryDate: '2024/06/02',
SaleAmount: 9050,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 87,
OrderNumber: 197474,
OrderDate: '2024/03/02',
DeliveryDate: '2024/03/03',
SaleAmount: 6400,
Terms: '30 Days',
Location: 'Reno, NV',
Customer: 'Clark Morgan',
}, {
ID: 88,
OrderNumber: 198746,
OrderDate: '2024/05/09',
DeliveryDate: '2024/05/12',
SaleAmount: 15700,
Terms: '30 Days',
Location: 'Denver, CO',
Customer: 'Todd Hoffman',
}, {
ID: 91,
OrderNumber: 214222,
OrderDate: '2024/02/08',
DeliveryDate: '2024/02/10',
SaleAmount: 11050,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>
Users can drag and drop header items to reorder columns when allowColumnReordering is set to true. To disable reorder operations for a specific field, assign false to its allowReordering property. In this demo, allowReordering is disabled for the OrderNumber field.

Backend API
import React from 'react';
import CardView, { Column } from 'devextreme-react/card-view';
import { orders } from './data.ts';
const App = () => (
<CardView
id="cardView"
dataSource={orders}
keyExpr="ID"
allowColumnReordering={true}
cardsPerRow="auto"
cardMinWidth={300}
>
<Column
dataField="OrderNumber"
allowReordering={false}
/>
<Column
dataField="SaleAmount"
/>
<Column
dataField="Customer"
/>
<Column
dataField="Location"
/>
<Column
dataField="OrderDate"
dataType="date"
/>
<Column
dataField="DeliveryDate"
dataType="date"
/>
</CardView>
);
export default App;
import React from 'react';
import CardView, { Column } from 'devextreme-react/card-view';
import { orders } from './data.js';
const App = () => (
<CardView
id="cardView"
dataSource={orders}
keyExpr="ID"
allowColumnReordering={true}
cardsPerRow="auto"
cardMinWidth={300}
>
<Column
dataField="OrderNumber"
allowReordering={false}
/>
<Column dataField="SaleAmount" />
<Column dataField="Customer" />
<Column dataField="Location" />
<Column
dataField="OrderDate"
dataType="date"
/>
<Column
dataField="DeliveryDate"
dataType="date"
/>
</CardView>
);
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export interface Order {
ID: number;
OrderNumber: number;
OrderDate: string;
DeliveryDate: string;
SaleAmount: number,
Terms: string;
Location: string;
Customer: string;
}
export const orders: Order[] = [{
ID: 1,
OrderNumber: 35703,
OrderDate: '2024/04/10',
DeliveryDate: '2024/04/13',
SaleAmount: 11800,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: '2024/01/12',
DeliveryDate: '2024/01/13',
SaleAmount: 16050,
Terms: '15 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: '2024/01/22',
DeliveryDate: '2024/01/27',
SaleAmount: 14750,
Terms: '15 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: '2024/02/07',
DeliveryDate: '2024/02/10',
SaleAmount: 3725,
Terms: '15 Days',
Location: 'Denver, CO',
Customer: 'Todd Hoffman',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: '2024/03/01',
DeliveryDate: '2024/03/03',
SaleAmount: 7800,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: '2024/02/15',
DeliveryDate: '2024/02/17',
SaleAmount: 20500,
Terms: '15 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: '2024/02/04',
DeliveryDate: '2024/02/10',
SaleAmount: 9050,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: '2024/02/15',
DeliveryDate: '2024/02/17',
SaleAmount: 20400,
Terms: '30 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: '2024/05/16',
DeliveryDate: '2024/05/19',
SaleAmount: 11050,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
}, {
ID: 32,
OrderNumber: 58292,
OrderDate: '2024/05/13',
DeliveryDate: '2024/05/19',
SaleAmount: 13500,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 36,
OrderNumber: 62427,
OrderDate: '2024/01/27',
DeliveryDate: '2024/02/03',
SaleAmount: 23500,
Terms: '15 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 39,
OrderNumber: 65977,
OrderDate: '2024/02/05',
DeliveryDate: '2024/02/10',
SaleAmount: 2550,
Terms: '15 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
}, {
ID: 42,
OrderNumber: 68428,
OrderDate: '2024/04/10',
DeliveryDate: '2024/04/14',
SaleAmount: 10500,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 43,
OrderNumber: 69477,
OrderDate: '2024/03/09',
DeliveryDate: '2024/03/10',
SaleAmount: 14200,
Terms: '15 Days',
Location: 'Anaheim, CA',
Customer: 'Harv Mudd',
}, {
ID: 46,
OrderNumber: 72947,
OrderDate: '2024/01/14',
DeliveryDate: '2024/01/20',
SaleAmount: 13350,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 47,
OrderNumber: 73088,
OrderDate: '2024/03/25',
DeliveryDate: '2024/03/31',
SaleAmount: 8600,
Terms: '30 Days',
Location: 'Reno, NV',
Customer: 'Clark Morgan',
}, {
ID: 51,
OrderNumber: 77297,
OrderDate: '2024/04/30',
DeliveryDate: '2024/05/05',
SaleAmount: 10850,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
}, {
ID: 56,
OrderNumber: 84744,
OrderDate: '2024/02/10',
DeliveryDate: '2024/02/17',
SaleAmount: 4650,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 57,
OrderNumber: 85028,
OrderDate: '2024/05/17',
DeliveryDate: '2024/05/19',
SaleAmount: 2575,
Terms: '30 Days',
Location: 'Reno, NV',
Customer: 'Clark Morgan',
}, {
ID: 59,
OrderNumber: 87297,
OrderDate: '2024/04/21',
DeliveryDate: '2024/04/28',
SaleAmount: 14200,
Terms: '30 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
}, {
ID: 65,
OrderNumber: 94726,
OrderDate: '2024/05/22',
DeliveryDate: '2024/05/26',
SaleAmount: 20500,
Terms: '15 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
}, {
ID: 66,
OrderNumber: 95266,
OrderDate: '2024/03/10',
DeliveryDate: '2024/03/17',
SaleAmount: 9050,
Terms: '15 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 69,
OrderNumber: 98477,
OrderDate: '2024/01/01',
DeliveryDate: '2024/01/06',
SaleAmount: 23500,
Terms: '15 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
}, {
ID: 78,
OrderNumber: 174884,
OrderDate: '2024/04/10',
DeliveryDate: '2024/04/14',
SaleAmount: 7200,
Terms: '30 Days',
Location: 'Denver, CO',
Customer: 'Todd Hoffman',
}, {
ID: 81,
OrderNumber: 188877,
OrderDate: '2024/02/11',
DeliveryDate: '2024/02/17',
SaleAmount: 8750,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
}, {
ID: 82,
OrderNumber: 191883,
OrderDate: '2024/02/05',
DeliveryDate: '2024/02/10',
SaleAmount: 9900,
Terms: '30 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 83,
OrderNumber: 192474,
OrderDate: '2024/01/21',
DeliveryDate: '2024/01/27',
SaleAmount: 12800,
Terms: '30 Days',
Location: 'Anaheim, CA',
Customer: 'Harv Mudd',
}, {
ID: 84,
OrderNumber: 193847,
OrderDate: '2024/03/21',
DeliveryDate: '2024/03/24',
SaleAmount: 14100,
Terms: '30 Days',
Location: 'San Diego, CA',
Customer: 'Harv Mudd',
}, {
ID: 85,
OrderNumber: 194877,
OrderDate: '2024/03/06',
DeliveryDate: '2024/03/10',
SaleAmount: 4750,
Terms: '30 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
}, {
ID: 86,
OrderNumber: 195746,
OrderDate: '2024/05/26',
DeliveryDate: '2024/06/02',
SaleAmount: 9050,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 87,
OrderNumber: 197474,
OrderDate: '2024/03/02',
DeliveryDate: '2024/03/03',
SaleAmount: 6400,
Terms: '30 Days',
Location: 'Reno, NV',
Customer: 'Clark Morgan',
}, {
ID: 88,
OrderNumber: 198746,
OrderDate: '2024/05/09',
DeliveryDate: '2024/05/12',
SaleAmount: 15700,
Terms: '30 Days',
Location: 'Denver, CO',
Customer: 'Todd Hoffman',
}, {
ID: 91,
OrderNumber: 214222,
OrderDate: '2024/02/08',
DeliveryDate: '2024/02/10',
SaleAmount: 11050,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const orders = [
{
ID: 1,
OrderNumber: 35703,
OrderDate: '2024/04/10',
DeliveryDate: '2024/04/13',
SaleAmount: 11800,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
},
{
ID: 4,
OrderNumber: 35711,
OrderDate: '2024/01/12',
DeliveryDate: '2024/01/13',
SaleAmount: 16050,
Terms: '15 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
},
{
ID: 5,
OrderNumber: 35714,
OrderDate: '2024/01/22',
DeliveryDate: '2024/01/27',
SaleAmount: 14750,
Terms: '15 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
},
{
ID: 7,
OrderNumber: 35983,
OrderDate: '2024/02/07',
DeliveryDate: '2024/02/10',
SaleAmount: 3725,
Terms: '15 Days',
Location: 'Denver, CO',
Customer: 'Todd Hoffman',
},
{
ID: 11,
OrderNumber: 38466,
OrderDate: '2024/03/01',
DeliveryDate: '2024/03/03',
SaleAmount: 7800,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
},
{
ID: 14,
OrderNumber: 39420,
OrderDate: '2024/02/15',
DeliveryDate: '2024/02/17',
SaleAmount: 20500,
Terms: '15 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
},
{
ID: 15,
OrderNumber: 39874,
OrderDate: '2024/02/04',
DeliveryDate: '2024/02/10',
SaleAmount: 9050,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
},
{
ID: 18,
OrderNumber: 42847,
OrderDate: '2024/02/15',
DeliveryDate: '2024/02/17',
SaleAmount: 20400,
Terms: '30 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
},
{
ID: 30,
OrderNumber: 57429,
OrderDate: '2024/05/16',
DeliveryDate: '2024/05/19',
SaleAmount: 11050,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
},
{
ID: 32,
OrderNumber: 58292,
OrderDate: '2024/05/13',
DeliveryDate: '2024/05/19',
SaleAmount: 13500,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
},
{
ID: 36,
OrderNumber: 62427,
OrderDate: '2024/01/27',
DeliveryDate: '2024/02/03',
SaleAmount: 23500,
Terms: '15 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
},
{
ID: 39,
OrderNumber: 65977,
OrderDate: '2024/02/05',
DeliveryDate: '2024/02/10',
SaleAmount: 2550,
Terms: '15 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
},
{
ID: 42,
OrderNumber: 68428,
OrderDate: '2024/04/10',
DeliveryDate: '2024/04/14',
SaleAmount: 10500,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
},
{
ID: 43,
OrderNumber: 69477,
OrderDate: '2024/03/09',
DeliveryDate: '2024/03/10',
SaleAmount: 14200,
Terms: '15 Days',
Location: 'Anaheim, CA',
Customer: 'Harv Mudd',
},
{
ID: 46,
OrderNumber: 72947,
OrderDate: '2024/01/14',
DeliveryDate: '2024/01/20',
SaleAmount: 13350,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
},
{
ID: 47,
OrderNumber: 73088,
OrderDate: '2024/03/25',
DeliveryDate: '2024/03/31',
SaleAmount: 8600,
Terms: '30 Days',
Location: 'Reno, NV',
Customer: 'Clark Morgan',
},
{
ID: 51,
OrderNumber: 77297,
OrderDate: '2024/04/30',
DeliveryDate: '2024/05/05',
SaleAmount: 10850,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
},
{
ID: 56,
OrderNumber: 84744,
OrderDate: '2024/02/10',
DeliveryDate: '2024/02/17',
SaleAmount: 4650,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
},
{
ID: 57,
OrderNumber: 85028,
OrderDate: '2024/05/17',
DeliveryDate: '2024/05/19',
SaleAmount: 2575,
Terms: '30 Days',
Location: 'Reno, NV',
Customer: 'Clark Morgan',
},
{
ID: 59,
OrderNumber: 87297,
OrderDate: '2024/04/21',
DeliveryDate: '2024/04/28',
SaleAmount: 14200,
Terms: '30 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
},
{
ID: 65,
OrderNumber: 94726,
OrderDate: '2024/05/22',
DeliveryDate: '2024/05/26',
SaleAmount: 20500,
Terms: '15 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
},
{
ID: 66,
OrderNumber: 95266,
OrderDate: '2024/03/10',
DeliveryDate: '2024/03/17',
SaleAmount: 9050,
Terms: '15 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
},
{
ID: 69,
OrderNumber: 98477,
OrderDate: '2024/01/01',
DeliveryDate: '2024/01/06',
SaleAmount: 23500,
Terms: '15 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
},
{
ID: 78,
OrderNumber: 174884,
OrderDate: '2024/04/10',
DeliveryDate: '2024/04/14',
SaleAmount: 7200,
Terms: '30 Days',
Location: 'Denver, CO',
Customer: 'Todd Hoffman',
},
{
ID: 81,
OrderNumber: 188877,
OrderDate: '2024/02/11',
DeliveryDate: '2024/02/17',
SaleAmount: 8750,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
},
{
ID: 82,
OrderNumber: 191883,
OrderDate: '2024/02/05',
DeliveryDate: '2024/02/10',
SaleAmount: 9900,
Terms: '30 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
},
{
ID: 83,
OrderNumber: 192474,
OrderDate: '2024/01/21',
DeliveryDate: '2024/01/27',
SaleAmount: 12800,
Terms: '30 Days',
Location: 'Anaheim, CA',
Customer: 'Harv Mudd',
},
{
ID: 84,
OrderNumber: 193847,
OrderDate: '2024/03/21',
DeliveryDate: '2024/03/24',
SaleAmount: 14100,
Terms: '30 Days',
Location: 'San Diego, CA',
Customer: 'Harv Mudd',
},
{
ID: 85,
OrderNumber: 194877,
OrderDate: '2024/03/06',
DeliveryDate: '2024/03/10',
SaleAmount: 4750,
Terms: '30 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
},
{
ID: 86,
OrderNumber: 195746,
OrderDate: '2024/05/26',
DeliveryDate: '2024/06/02',
SaleAmount: 9050,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
},
{
ID: 87,
OrderNumber: 197474,
OrderDate: '2024/03/02',
DeliveryDate: '2024/03/03',
SaleAmount: 6400,
Terms: '30 Days',
Location: 'Reno, NV',
Customer: 'Clark Morgan',
},
{
ID: 88,
OrderNumber: 198746,
OrderDate: '2024/05/09',
DeliveryDate: '2024/05/12',
SaleAmount: 15700,
Terms: '30 Days',
Location: 'Denver, CO',
Customer: 'Todd Hoffman',
},
{
ID: 91,
OrderNumber: 214222,
OrderDate: '2024/02/08',
DeliveryDate: '2024/02/10',
SaleAmount: 11050,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
<link rel="stylesheet" type="text/css" href="styles.css" />
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
Users can drag and drop header items to reorder columns when allowColumnReordering is set to true. To disable reorder operations for a specific field, assign false to its allowReordering property. In this demo, allowReordering is disabled for the OrderNumber field.

Backend API
<dx-card-view
id="cardView"
[dataSource]="orders"
keyExpr="ID"
[allowColumnReordering]="true"
cardsPerRow="auto"
[cardMinWidth]="300"
>
<dxi-card-view-column
dataField="OrderNumber"
[allowReordering]="false"
></dxi-card-view-column>
<dxi-card-view-column dataField="SaleAmount"></dxi-card-view-column>
<dxi-card-view-column dataField="Customer"></dxi-card-view-column>
<dxi-card-view-column dataField="Location"></dxi-card-view-column>
<dxi-card-view-column
dataField="OrderDate"
dataType="date"
></dxi-card-view-column>
<dxi-card-view-column
dataField="DeliveryDate"
dataType="date"
></dxi-card-view-column>
</dx-card-view>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxCardViewModule } from 'devextreme-angular';
import { Order, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
styleUrls: [`app/app.component.css`],
selector: 'demo-app',
templateUrl: `app/app.component.html`,
providers: [Service],
imports: [
DxCardViewModule,
],
})
export class AppComponent {
orders: Order[];
constructor(service: Service) {
this.orders = service.getOrder();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
import { Injectable } from '@angular/core';
export interface Order {
ID: number;
OrderNumber: number;
OrderDate: string;
DeliveryDate: string;
SaleAmount: number,
Terms: string;
Location: string;
Customer: string;
}
const orders: Order[] = [{
ID: 1,
OrderNumber: 35703,
OrderDate: '2024/04/10',
DeliveryDate: '2024/04/13',
SaleAmount: 11800,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: '2024/01/12',
DeliveryDate: '2024/01/13',
SaleAmount: 16050,
Terms: '15 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: '2024/01/22',
DeliveryDate: '2024/01/27',
SaleAmount: 14750,
Terms: '15 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: '2024/02/07',
DeliveryDate: '2024/02/10',
SaleAmount: 3725,
Terms: '15 Days',
Location: 'Denver, CO',
Customer: 'Todd Hoffman',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: '2024/03/01',
DeliveryDate: '2024/03/03',
SaleAmount: 7800,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: '2024/02/15',
DeliveryDate: '2024/02/17',
SaleAmount: 20500,
Terms: '15 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: '2024/02/04',
DeliveryDate: '2024/02/10',
SaleAmount: 9050,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: '2024/02/15',
DeliveryDate: '2024/02/17',
SaleAmount: 20400,
Terms: '30 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: '2024/05/16',
DeliveryDate: '2024/05/19',
SaleAmount: 11050,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
}, {
ID: 32,
OrderNumber: 58292,
OrderDate: '2024/05/13',
DeliveryDate: '2024/05/19',
SaleAmount: 13500,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 36,
OrderNumber: 62427,
OrderDate: '2024/01/27',
DeliveryDate: '2024/02/03',
SaleAmount: 23500,
Terms: '15 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 39,
OrderNumber: 65977,
OrderDate: '2024/02/05',
DeliveryDate: '2024/02/10',
SaleAmount: 2550,
Terms: '15 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
}, {
ID: 42,
OrderNumber: 68428,
OrderDate: '2024/04/10',
DeliveryDate: '2024/04/14',
SaleAmount: 10500,
Terms: '15 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 43,
OrderNumber: 69477,
OrderDate: '2024/03/09',
DeliveryDate: '2024/03/10',
SaleAmount: 14200,
Terms: '15 Days',
Location: 'Anaheim, CA',
Customer: 'Harv Mudd',
}, {
ID: 46,
OrderNumber: 72947,
OrderDate: '2024/01/14',
DeliveryDate: '2024/01/20',
SaleAmount: 13350,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 47,
OrderNumber: 73088,
OrderDate: '2024/03/25',
DeliveryDate: '2024/03/31',
SaleAmount: 8600,
Terms: '30 Days',
Location: 'Reno, NV',
Customer: 'Clark Morgan',
}, {
ID: 51,
OrderNumber: 77297,
OrderDate: '2024/04/30',
DeliveryDate: '2024/05/05',
SaleAmount: 10850,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
}, {
ID: 56,
OrderNumber: 84744,
OrderDate: '2024/02/10',
DeliveryDate: '2024/02/17',
SaleAmount: 4650,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 57,
OrderNumber: 85028,
OrderDate: '2024/05/17',
DeliveryDate: '2024/05/19',
SaleAmount: 2575,
Terms: '30 Days',
Location: 'Reno, NV',
Customer: 'Clark Morgan',
}, {
ID: 59,
OrderNumber: 87297,
OrderDate: '2024/04/21',
DeliveryDate: '2024/04/28',
SaleAmount: 14200,
Terms: '30 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
}, {
ID: 65,
OrderNumber: 94726,
OrderDate: '2024/05/22',
DeliveryDate: '2024/05/26',
SaleAmount: 20500,
Terms: '15 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
}, {
ID: 66,
OrderNumber: 95266,
OrderDate: '2024/03/10',
DeliveryDate: '2024/03/17',
SaleAmount: 9050,
Terms: '15 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 69,
OrderNumber: 98477,
OrderDate: '2024/01/01',
DeliveryDate: '2024/01/06',
SaleAmount: 23500,
Terms: '15 Days',
Location: 'Casper, WY',
Customer: 'Todd Hoffman',
}, {
ID: 78,
OrderNumber: 174884,
OrderDate: '2024/04/10',
DeliveryDate: '2024/04/14',
SaleAmount: 7200,
Terms: '30 Days',
Location: 'Denver, CO',
Customer: 'Todd Hoffman',
}, {
ID: 81,
OrderNumber: 188877,
OrderDate: '2024/02/11',
DeliveryDate: '2024/02/17',
SaleAmount: 8750,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
}, {
ID: 82,
OrderNumber: 191883,
OrderDate: '2024/02/05',
DeliveryDate: '2024/02/10',
SaleAmount: 9900,
Terms: '30 Days',
Location: 'Los Angeles, CA',
Customer: 'Harv Mudd',
}, {
ID: 83,
OrderNumber: 192474,
OrderDate: '2024/01/21',
DeliveryDate: '2024/01/27',
SaleAmount: 12800,
Terms: '30 Days',
Location: 'Anaheim, CA',
Customer: 'Harv Mudd',
}, {
ID: 84,
OrderNumber: 193847,
OrderDate: '2024/03/21',
DeliveryDate: '2024/03/24',
SaleAmount: 14100,
Terms: '30 Days',
Location: 'San Diego, CA',
Customer: 'Harv Mudd',
}, {
ID: 85,
OrderNumber: 194877,
OrderDate: '2024/03/06',
DeliveryDate: '2024/03/10',
SaleAmount: 4750,
Terms: '30 Days',
Location: 'San Jose, CA',
Customer: 'Jim Packard',
}, {
ID: 86,
OrderNumber: 195746,
OrderDate: '2024/05/26',
DeliveryDate: '2024/06/02',
SaleAmount: 9050,
Terms: '30 Days',
Location: 'Las Vegas, NV',
Customer: 'Harv Mudd',
}, {
ID: 87,
OrderNumber: 197474,
OrderDate: '2024/03/02',
DeliveryDate: '2024/03/03',
SaleAmount: 6400,
Terms: '30 Days',
Location: 'Reno, NV',
Customer: 'Clark Morgan',
}, {
ID: 88,
OrderNumber: 198746,
OrderDate: '2024/05/09',
DeliveryDate: '2024/05/12',
SaleAmount: 15700,
Terms: '30 Days',
Location: 'Denver, CO',
Customer: 'Todd Hoffman',
}, {
ID: 91,
OrderNumber: 214222,
OrderDate: '2024/02/08',
DeliveryDate: '2024/02/10',
SaleAmount: 11050,
Terms: '30 Days',
Location: 'Phoenix, AZ',
Customer: 'Clark Morgan',
}];
@Injectable()
export class Service {
getOrder() {
return orders;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
Users can drag and drop header items to reorder columns when allowColumnReordering is set to true. To disable reorder operations for a specific field, assign false to its allowReordering property. In this demo, allowReordering is disabled for the OrderNumber field.